----------------------------------------------------------------------------------
-- Company: Univ Lyon, UJM-Saint-Etienne, CNRS, Laboratoire Hubert Curien UMR 5516, F-42023, SAINT-ETIENNE, France
-- Creator: Cédric Marchand 
-- 
-- Create Date:    18:07:09 11/11/2015 
-- Design Name: 
-- Module Name:    Datapath - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

LIBRARY work;
USE work.API_pkg.ALL;

entity Datapath is
  PORT(
    clk_i : in std_logic; -- Clock
    --Input
    data_i    : in std_logic_vector(7 downto 0); -- data input
    key_i     : in std_logic_vector(7 downto 0); -- key input
    --Control
    mode_i    : in std_logic; -- 0 = Encryption, 1 = Decryption
    key_sel   : in std_logic_vector(1 downto 0); -- Control signal for the key multiplexer
    data_sel  : in std_logic_vector(1 downto 0); -- Control signal for the data multiplexer
    count_r   : in std_logic_vector(4 downto 0); -- round counter
    --Output
    data_o    : out std_logic_vector(7 downto 0) -- data output
  );
end Datapath;

architecture Behavioral of Datapath is

  --Components declarations
  
  --signals
  --regsiters
  signal key_reg      : std_logic_vector(key_size-1 downto 0);
  signal state_reg    : std_logic_vector(state_size-1 downto 0);
  --process signals

  
begin
  --key process
  K_proc : process(clk_i, key_sel)
  begin
    if rising_edge(clk_i) then
      if key_sel = "01" then
        key_reg <= key_i & key_reg(key_size-1 downto 8); -- load key
      -- Insert other condition depending of what you are implementing
	  
      end if;
    end if;
  end process;
  
  --data process
  D_proc : process(clk_i, data_sel)
  begin
    if rising_edge(clk_i) then
      if data_sel = "01" then
        state_reg <=  state_reg(state_size-9 downto 0) & data_i; -- load data
      -- Insert other condition depending of what you are implementing
	  
      end if;
    end if;
  end process;
  
  data_o <= state_reg(59 downto 56) & state_reg(63 downto 60); -- & state_reg(7 downto 4); -- Data output
  
end Behavioral;

